<template lang="fr">
  <div>
    <router-link tag="button" :to="{ name: 'Planets'}" class="btn btn-primary mb-4">
      Return to planets
    </router-link>
    <div class="d-flex flex-row justify-content-start align-items-center mb-3">
      <Favorite :id="planet.id" :name="planet.name" :favorite="favorite" @update="updateFavorite"/>
      <h1 class="ml-3">{{ planet.name }}</h1>
    </div>
    <p>
      {{ planet.name }} (of its English name : {{ planet.englishName }}) is
      {{ planet.isPlanet ? "a planet" : "not a planet" }} with actually
      {{ planet.moons === null ? "0" : "some" }} moon(s).
    </p>

    <h2>Other informations</h2>
    <ul>
      <li>Semimajor Axis: {{ planet.semimajorAxis }}</li>
      <li>Semimajor: {{ planet.semimajorAxis }}</li>
      <li>Perihelion: {{ planet.perihelion }}</li>
      <li>Aphelion: {{ planet.aphelion }}</li>
      <li>Eccentricity: {{ planet.eccentricity }}</li>
      <li>Inclination: {{ planet.inclination }}</li>
      <li>Density: {{ planet.density }}</li>
      <li>Gravity: {{ planet.gravity }}</li>
      <li>MeanRadius: {{ planet.meanRadius }}</li>
      <li>EquaRadius: {{ planet.equaRadius }}</li>
      <li>PolarRadius: {{ planet.polarRadius }}</li>
      <li>Flattening: {{ planet.flattening }}</li>
      <li>Dimension: {{ planet.dimension }}</li>
      <li>SideralOrbit: {{ planet.sideralOrbit }}</li>
      <li>SideralRotation: {{ planet.sideralRotation }}</li>
      <li>DiscoveredBy: {{ planet.discoveredBy }}</li>
      <li>DiscoveryDate: {{ planet.discoveryDate }}</li>
      <li>
        AlternativeName: {{ planet.alternativeName && "No alternative name" }}
      </li>
      <li>AxialTilt: {{ planet.axialTilt }}</li>
    </ul>

    <h2>Moons</h2>
    <div v-if="planet.moons !== null">
      <Table :datas="moons" />
    </div>
    <p v-else>{{ planet.name }} ({{ planet.englishName }}) has no moons.</p>
  </div>
</template>

<script>
import PlanetAPI from "./../services/index";
import Table from "./../components/Table";
import Favorite from "./../components/Favorite";

export default {
  name: "PlanetPage",
  components: {
    Table,
    Favorite,
  },
  data() {
    return {
      planet: {},
      moons: [],
      favorite: false,
    };
  },
  props: {
    id: String,
  },
  methods: {
    getDatas() {
      this.getPlanet();
    },
    async getPlanet() {
      this.planet = await PlanetAPI.find(this.id);
      if (this.planet.moons !== null) {
        this.planet.moons.forEach(({ rel }) => {
          this.getMoon(rel);
        });
      }
    },
    async getMoon(rel) {
      const response = await PlanetAPI.findByUrl(rel);
      this.moons.push(response);
    },
    updateFavorite(value) {
      this.favorite = value;
    },
  },
  mounted() {
    this.getDatas();
    const favorites = this.$store.state.favorites;
    favorites.map((f) => {
      if (f === this.id) {
        this.favorite = true;
      }
    });
  },
  beforeUpdate() {
    if (this.planet.id !== this.id) {
      this.getPlanet();
    }
  },
};
</script>

<style scoped>
img {
  width: 30px;
}

h1 {
  margin-bottom: 0;
}
</style>
